---
title: Xamarin.Android error ADB0030
description: ADB0030 error code
ms.date: 07/04/2018
---
# Xamarin.Android error ADB0030

## Example messages

```
error ADB0030: Failure [INSTALL_PARSE_FAILED_INCONSISTENT_CERTIFICATES]
```

```
error ADB0030: Failure [INSTALL_FAILED_UPDATE_INCOMPATIBLE]
```

## Issue

ADB0030 means that you must manually uninstall your APK before you
can deploy your Xamarin.Android application to the attached device or
emulator. This situation can happen if you had deployed your
Xamarin.Android application in the past, but it was signed with a
different Android keystore file.

This message indicates that `adb` (Android Debug Bridge) reported an
error. `adb` is part of the Android SDK and is used internally by
Xamarin.Android to communicate with Android emulators and devices.
Learn more about `adb` from the [Android documentation][adb].

## Solution

Manually uninstall your APK from the attached device or emulator.

[adb]: https://developer.android.com/studio/command-line/adb

## Implementation notes

Note that nothing in the open source xamarin-android repository
emits ADB0030, as features such as debugging and "fast deployment"
are implemented in the proprietary Xamarin.Android additions.
