---
title: Xamarin.Android error ADB0050
description: ADB0050 error code
ms.date: 07/04/2018
---
# Xamarin.Android error ADB0050

## Example messages

```
error ADB0050: Failure [INSTALL_FAILED_ALREADY_EXISTS]
```

## Issue

ADB0050 is likely an error in the Xamarin.Android build chain, since
it means there was an absence of the `-r` flag during the
`adb install` command.

This message indicates that `adb` (Android Debug Bridge) reported an
error. `adb` is part of the Android SDK and is used internally by
Xamarin.Android to communicate with Android emulators and devices.
Learn more about `adb` from the [Android documentation][adb].

## Solution

Consider submitting a [bug][bug] if you are getting this warning under
normal circumstances.

[adb]: https://developer.android.com/studio/command-line/adb
[bug]: https://github.com/xamarin/xamarin-android/wiki/Submitting-Bugs,-Feature-Requests,-and-Pull-Requests

## Implementation notes

Note that nothing in the open source xamarin-android repository
emits ADB0050, as features such as debugging and "fast deployment"
are implemented in the proprietary Xamarin.Android additions.
