---
title: Xamarin.Android warning XA0111
description: XA0111 warning code
ms.date: 05/10/2019
---
# Xamarin.Android warning XA0111

## Issue

Xamarin.Android could not get the `aapt2` version via the command:

```
aapt2 -version
```

`aapt2` did not return an expected value.

## Solution

Try re-installing the android build-tools.

`aapt` is part of the Android SDK and is used internally by
Xamarin.Android to process and compile resources into binary assets.
Learn more about `aapt` and Android resources from the [Android
documentation][aapt].

`aapt2` is version 2.0 of `aapt`. Learn more about `aapt2` from the
[Android documentation][aapt2].

[aapt]: https://developer.android.com/guide/topics/resources/accessing-resources.html
[aapt2]: https://developer.android.com/studio/command-line/aapt2
